SystemOrganization addCategory: #GoLight!
SystemOrganization addCategory: #'GoLight-Tests'!

Object subclass: #GoLight
	instanceVariableNames: 'greenBulb yellowBulb redBulb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLight methodsFor: 'default' stamp: 'rkrk 2/17/2008 17:33'!
defaultGreenBulbSocket

	^ 1! !

!GoLight methodsFor: 'default' stamp: 'rkrk 2/17/2008 17:34'!
defaultRedBulbSocket

	^ 3! !

!GoLight methodsFor: 'default' stamp: 'rkrk 2/17/2008 17:33'!
defaultYellowBulbSocket

	^ 2! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:24'!
greenBulb

	"^ <GoLightBulb>"
	^ greenBulb! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:24'!
greenBulb: anObject

	greenBulb := anObject! !

!GoLight methodsFor: 'initialize-release' stamp: 'rkrk 2/18/2008 00:12'!
initialize

	super initialize.
	greenBulb := GoLightBulb
		forSocket: self defaultGreenBulbSocket
		andPowerManager: GoLightPowerManager singleInstance.
	yellowBulb := GoLightBulb
		forSocket: self defaultYellowBulbSocket
		andPowerManager: GoLightPowerManager singleInstance.
	redBulb := GoLightBulb
		forSocket: self defaultRedBulbSocket
		andPowerManager: GoLightPowerManager singleInstance.! !

!GoLight methodsFor: 'versionLoading' stamp: 'rkrk 2/17/2008 17:43'!
loadNewestVersions

	mcController loadNewestVersion.! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:23'!
redBulb

	"^ <GoLightBulb>"
	^ redBulb! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:24'!
redBulb: anObject

	redBulb := anObject! !

!GoLight methodsFor: 'modifying lights' stamp: 'rkrk 2/17/2008 21:21'!
testsFail

	self turnLightsOff.
	self	yellowBulb on.! !

!GoLight methodsFor: 'modifying lights' stamp: 'rkrk 2/17/2008 21:08'!
testsPass

	self turnLightsOff.
	self	greenBulb on.! !

!GoLight methodsFor: 'modifying lights' stamp: 'rkrk 2/17/2008 21:21'!
testsThrowErrors

	self turnLightsOff.
	self	redBulb on.! !

!GoLight methodsFor: 'modifying lights' stamp: 'rkrk 2/17/2008 21:08'!
turnLightsOff

	self greenBulb off.
	self yellowBulb off.
	self redBulb off.! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:23'!
yellowBulb

	"^ <GoLightBulb>"
	^ yellowBulb! !

!GoLight methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:24'!
yellowBulb: anObject

	yellowBulb := anObject! !

Object subclass: #GoLightBulb
	instanceVariableNames: 'socketNumber state powerManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLightBulb class methodsFor: 'instance creation' stamp: 'rkrk 2/17/2008 20:01'!
forSocket: anInteger andPowerManager: powerManager

	^ self new
		socketNumber: anInteger;
		powerManager: powerManager;
		yourself.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:40'!
blink

	self blinkWithDelayForMilliSeconds: 850.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:40'!
blinkMedium

	self blinkWithDelayForMilliSeconds: 200.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:40'!
blinkQuick

	self blinkWithDelayForMilliSeconds: 10.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:40'!
blinkSlow

	self blinkWithDelayForMilliSeconds: 2000.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:39'!
blinkWithDelayForMilliSeconds: aNumber

	self on.
	(Delay forSeconds: aNumber) wait.
	self off.! !

!GoLightBulb methodsFor: 'initialize-release' stamp: 'rkrk 2/17/2008 17:49'!
initialize

	super initialize.
	self state: #off.! !

!GoLightBulb methodsFor: 'testing' stamp: 'rkrk 2/17/2008 15:51'!
isOn

	^ self state = #on! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 21:13'!
off
	
	self isOn ifFalse: [^ self].
	self	state: #off.
	self powerManager
		setSocket: self socketNumber
		toState: self state.! !

!GoLightBulb methodsFor: 'modify state' stamp: 'rkrk 2/17/2008 15:52'!
on
	
	self isOn ifTrue: [^ self].
	self	state: #on.
	self powerManager
		setSocket: self socketNumber
		toState: self state.
	! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:22'!
powerManager
	
	"^ <GoLightPowerManager>"
	^ powerManager! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 15:48'!
powerManager: aGoLightPowerManager
	
	powerManager := aGoLightPowerManager! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 18:23'!
socketNumber
	
	"^ <Integer>"
	^ socketNumber! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 15:00'!
socketNumber: anInteger
	
	socketNumber := anInteger! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 15:55'!
state

	"^ #on | #off"
	^ state! !

!GoLightBulb methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 00:20'!
state: aSymbol 

	self assert: (aSymbol = #on or: [aSymbol = #off]).
	state := aSymbol.! !

Object subclass: #GoLightPowerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLightPowerManager class methodsFor: 'instance creation' stamp: 'rkrk 2/17/2008 17:38'!
new

	self shouldNotImplement! !

!GoLightPowerManager class methodsFor: 'instance creation' stamp: 'rkrk 2/17/2008 17:37'!
singleInstance

	^ self allInstances
		ifEmpty: [self basicNew; initialize]
		ifNotEmptyDo: [:col | col first].! !

!GoLightPowerManager methodsFor: 'OSProcess' stamp: 'rkrk 2/17/2008 21:37'!
executeViaOSProcessSynchronously: command

	| p |
	p := ExternalOSProcess command: command.
	[p isComplete] whileFalse: [(Delay forMilliseconds: 5) wait].! !

!GoLightPowerManager methodsFor: 'initialize-release' stamp: 'rkrk 2/17/2008 15:17'!
initialize

	super initialize.
	self start.! !

!GoLightPowerManager methodsFor: 'operating' stamp: 'rkrk 2/17/2008 15:22'!
setSocket:  socketNumber toState: socketState

	| command |
	command := 'pm2.exe -' , socketState asString , ' -Device1 -Socket' , socketNumber asString.
	self executeViaOSProcessSynchronously: command.! !

!GoLightPowerManager methodsFor: 'initialize-release' stamp: 'rkrk 2/17/2008 15:19'!
start

	self executeViaOSProcessSynchronously: 'pm2.exe'! !

GoLightPowerManager subclass: #GoLightPowerManagerMock
	instanceVariableNames: 'setSocketToStateTestBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightPowerManagerMock class methodsFor: 'instance creation' stamp: 'rkrk 2/17/2008 17:40'!
new

	^ self basicNew initialize! !

!GoLightPowerManagerMock methodsFor: 'OSProcess' stamp: 'rkrk 2/17/2008 15:28'!
executeViaOSProcessSynchronously: command

	"I am only a mock. I do nothing."! !

!GoLightPowerManagerMock methodsFor: 'as yet unclassified' stamp: 'rkrk 2/17/2008 21:19'!
initialize

	super initialize.
	self setSocketToStateTestBlock: [:socketNumber :socketState |].! !

!GoLightPowerManagerMock methodsFor: 'operating' stamp: 'rkrk 2/17/2008 15:52'!
setSocket:  socketNumber toState: socketState

	"Evaluate the test block"
	self setSocketToStateTestBlock
		value: socketNumber
		value: socketState! !

!GoLightPowerManagerMock methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 15:29'!
setSocketToStateTestBlock

	^ setSocketToStateTestBlock! !

!GoLightPowerManagerMock methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 15:30'!
setSocketToStateTestBlock: aBlock

	setSocketToStateTestBlock := aBlock! !

Object subclass: #GoLightTester
	instanceVariableNames: 'versionUpdater goLight testTime activeProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLightTester class methodsFor: 'instance creation' stamp: 'rkrk 2/18/2008 01:46'!
forMCPackage: aMCPackage 
		
	^ self new
		versionUpdater: (GoLightVersionUpdater forMCPackage: aMCPackage);
		yourself.! !

!GoLightTester class methodsFor: 'instance creation' stamp: 'rkrk 2/18/2008 01:46'!
forMCPackageNamed: packageName 

	^ self forMCPackage: (MCPackage allInstances detect: [:each | each name = packageName])! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:20'!
activeProcess

	"^ <Process>"
	^ activeProcess! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 22:54'!
activeProcess: aProcess

	activeProcess := aProcess! !

!GoLightTester methodsFor: 'running' stamp: 'rkrk 2/18/2008 00:47'!
basicRun

	| testResult |
	testResult :=	self buildAndRunTestSuite.
	testResult errors ifNotEmpty: [self goLight testsThrowErrors. ^ self].
	testResult defects ifNotEmpty: [self goLight testsFail. ^ self].
	self goLight testsPass.! !

!GoLightTester methodsFor: 'running' stamp: 'rkrk 2/17/2008 22:26'!
buildAndRunTestSuite

	^ (TestSuite
		classes: self testClasses 
		suites: TestReporter defaultSuites
		select:  #() reject: #()) run.! !

!GoLightTester methodsFor: 'default' stamp: 'rkrk 2/17/2008 22:50'!
defaultTestTime

	^ GoLightTestTime
		delay: (Delay forDuration: (Duration minutes: 20))
		start: (Time hour: 8 minute: 0 second: 0)
		end: (Time hour: 22 minute: 45 second: 0)
		testingDays: #(#Monday #Tuesday #Wednesday #Thursday #Friday).! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 21:12'!
goLight

	"^ <GoLight>"
	^ goLight! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 21:10'!
goLight: aGoLight

	goLight := aGoLight.! !

!GoLightTester methodsFor: 'initialize-release' stamp: 'rkrk 2/18/2008 00:14'!
initialize

	super initialize.
	self
		goLight: GoLight new;
		testTime: self defaultTestTime.! !

!GoLightTester methodsFor: 'running' stamp: 'rkrk 2/18/2008 01:39'!
run

	(self testTime activeAtDateAndTime: DateAndTime current) 
		ifFalse: [self goLight turnLightsOff]
		ifTrue: [	self versionUpdater loadNewestVersion.
				self basicRun].! !

!GoLightTester methodsFor: 'user control' stamp: 'rkrk 2/18/2008 00:46'!
startCycle
	self stopCycle.
	self 
		activeProcess: 
			[[self basicRun.	"loadNewestVersions;"
			self testTime delay wait] repeat] 
					fork! !

!GoLightTester methodsFor: 'user control' stamp: 'rkrk 2/17/2008 22:31'!
stopCycle

	self activeProcess ifNotNilDo: [:process | process terminate]! !

!GoLightTester methodsFor: 'derived accessing' stamp: 'rkrk 2/18/2008 01:35'!
testClasses

	"^ Collection of: <Class>"
	^ self versionUpdater versionedClasses select: [:each | each inheritsFrom: TestCase]! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 00:39'!
testTime

	"^ <GoLightTestTime>"
	^ testTime! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 22:37'!
testTime: aGoLightTestTime

	testTime := aGoLightTestTime.! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:31'!
versionUpdater
	^ versionUpdater! !

!GoLightTester methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:31'!
versionUpdater: anObject
	versionUpdater := anObject! !

Object subclass: #GoLightVersionUpdater
	instanceVariableNames: 'mcPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLightVersionUpdater class methodsFor: 'instance creation' stamp: 'rkrk 2/18/2008 01:46'!
forMCPackage: aMCPackage 
	
	^ self new
		mcPackage: aMCPackage;
		yourself.! !

!GoLightVersionUpdater methodsFor: 'finding' stamp: 'rkrk 2/18/2008 01:25'!
findNameOfNewestVersionOf: aCollection 
	
	| biggestVersionNumber eachVersionNumber |
	self assert: aCollection isEmpty not.
	^ aCollection inject: aCollection first into: [:biggestVersion :each |
			biggestVersionNumber := (biggestVersion subStrings: '.') last asNumber.
			eachVersionNumber := (each subStrings: '.') last asNumber.
			biggestVersionNumber < eachVersionNumber
				ifTrue: [each]
				ifFalse: [biggestVersion]].! !

!GoLightVersionUpdater methodsFor: 'loading' stamp: 'rkrk 2/18/2008 01:27'!
loadNewestVersion

	| newestVersion |
	self mcPackage hasWorkingCopy ifFalse: [^ self].
	self mcPackage workingCopy possiblyNewerVersions
		ifEmpty: [^self]
		ifNotEmptyDo: [:namesOfNewVersions |
			newestVersion := self findNameOfNewestVersionOf: namesOfNewVersions.
			(self versionFromName: newestVersion) load].
	
	! !

!GoLightVersionUpdater methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:40'!
mcPackage

	"^ <MCPackage>"
	^ mcPackage! !

!GoLightVersionUpdater methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:40'!
mcPackage: aMCPackage

	mcPackage := aMCPackage! !

!GoLightVersionUpdater methodsFor: 'loading' stamp: 'rkrk 2/18/2008 01:27'!
versionFromName: nameOfMCVersion

	| repository |
	repository := self mcPackage workingCopy repositoryGroup  repositories detect: [:each | 
		each includesVersionNamed: nameOfMCVersion].
	^ repository versionFromFileNamed: nameOfMCVersion , '.mcz'.
	
	! !

!GoLightVersionUpdater methodsFor: 'loading' stamp: 'rkrk 2/18/2008 01:35'!
versionedClasses

	"^ Collection of: <Class>"
	^ self mcPackage packageInfo classes
! !

Magnitude subclass: #GoLightTestTime
	instanceVariableNames: 'start end testingDays delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight'!

!GoLightTestTime class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/17/2008 22:43'!
delay: delay start: startTime end: endTime testingDays: aCollection 

	^ self new
		delay: delay;
		start: startTime;
		end: endTime;
		testingDays: aCollection;
		yourself! !

!GoLightTestTime class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/17/2008 17:11'!
start: startTime end: endTime testingDays: aCollection 

	^ self new
		start: startTime;
		end: endTime;
		testingDays: aCollection;
		yourself! !

!GoLightTestTime methodsFor: 'testing' stamp: 'rkrk 2/17/2008 23:00'!
activeAtDateAndTime: aDateAndTime

	^ (aDateAndTime between: self start and: self end) and:
		[self testingDays includes: aDateAndTime dayOfWeekName]! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/18/2008 01:52'!
delay

	"^ <Delay>"
	^ delay copy! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 22:44'!
delay: aDelay

	delay := aDelay.! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 17:06'!
end

	"^ <Time>"
	^ end! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 16:32'!
end: aTime

	end := aTime! !

!GoLightTestTime methodsFor: 'initialize-release' stamp: 'rkrk 2/17/2008 17:03'!
initialize

	super initialize.
	self testingDays: Set new.! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 17:06'!
start

	"^ <Time>"
	^ start! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 16:31'!
start: aTime

	start := aTime! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 16:59'!
testingDays
	
	"^ <Collection of: Symbol>"
	^ testingDays! !

!GoLightTestTime methodsFor: 'accessing' stamp: 'rkrk 2/17/2008 17:10'!
testingDays: aCollection

	testingDays := aCollection.! !

TestCase subclass: #GoLightAcceptanceTest
	instanceVariableNames: 'golight golightTester dummyMCPackage powerManagerMock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightAcceptanceTest methodsFor: 'assertion' stamp: 'rkrk 2/17/2008 21:17'!
assertAllBulbsOfGolightAreOff

	self deny: golight greenBulb isOn.
	self deny: golight yellowBulb isOn.
	self deny: golight redBulb isOn.
! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:38'!
createDefectiveTestInDummyTestClass

	| class |
	class := Smalltalk classNamed: self dummyTestClassName.
	class compile: 'testThisTestShouldThrowAnError self error'. ! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:15'!
createDummyCategory

	Smalltalk organization addCategory: self dummyCategoryName.! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:49'!
createDummyMCPackage
	
	dummyMCPackage := MCPackage named: self dummyCategoryBasicName! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:21'!
createDummyTestClass
	
	TestCase
		subclass: self dummyTestClassName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self dummyCategoryName.! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:38'!
createFailingTestInDummyTestClass

	| class |
	class := Smalltalk classNamed: self dummyTestClassName.
	class compile: 'testThisTestShouldFail self assert: false'. ! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:52'!
createGoLight
	
	golight := GoLight new.
	"Use the PowerManagerMock for testing"
	powerManagerMock := GoLightPowerManagerMock new.
	golight greenBulb powerManager: powerManagerMock.
	golight yellowBulb powerManager: powerManagerMock.
	golight redBulb powerManager: powerManagerMock.! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/17/2008 20:25'!
createPassingTestInDummyTestClass

	| class |
	class := Smalltalk classNamed: self dummyTestClassName.
	class compile: 'testThisTestShouldPass self assert: true'.! !

!GoLightAcceptanceTest methodsFor: 'creation' stamp: 'rkrk 2/18/2008 01:44'!
createTestRunner

	| testTime |
	golightTester := GoLightTester forMCPackage: dummyMCPackage.
	testTime := GoLightTestTime 
				delay: (Delay forSeconds: 1)
				start: (Time now addSeconds: -120)
				end: (Time now addSeconds: 120)
				testingDays: { (Date today dayOfWeekName)}.
	golightTester
		goLight: golight;
		testTime: testTime.! !

!GoLightAcceptanceTest methodsFor: 'default' stamp: 'rkrk 2/17/2008 20:49'!
dummyCategoryBasicName

	^ (self dummyCategoryName subStrings: '-') first! !

!GoLightAcceptanceTest methodsFor: 'default' stamp: 'rkrk 2/17/2008 20:16'!
dummyCategoryName

	^ 'GoLightAcceptanceTest-DummyCategory'! !

!GoLightAcceptanceTest methodsFor: 'default' stamp: 'rkrk 2/17/2008 20:22'!
dummyTestClassName

	^ 'GoLightDummyTestClass'! !

!GoLightAcceptanceTest methodsFor: 'running' stamp: 'rkrk 2/17/2008 21:00'!
setUp

	super setUp.
	
	self
		createDummyCategory;
		createDummyTestClass;
		createDummyMCPackage;
		createGoLight;
		createTestRunner.
	! !

!GoLightAcceptanceTest methodsFor: 'running' stamp: 'rkrk 2/17/2008 20:49'!
tearDown

	super tearDown.
	
	dummyMCPackage unload.
	Smalltalk organization removeSystemCategory: self dummyCategoryName.! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/18/2008 00:53'!
testLightsShouldBeOffBecauseNotInTime

	golightTester testTime start: (Time now addSeconds: 20).
	self createFailingTestInDummyTestClass.
	self assertAllBulbsOfGolightAreOff.
	golightTester run.
	self assertAllBulbsOfGolightAreOff! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/18/2008 02:04'!
testOSProcessShouldBeAbleToExecuteExternalPowerManagerApplication

	self flag: #rkrk. "Make plattform independent."
	OSProcessAccessor forThisOSProcess isExecutable: 'pm2.exe'.! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/18/2008 00:48'!
testOSProcessShouldBeInstalled

	Smalltalk at: #OSProcess ifAbsent: [self assert: false]! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/18/2008 00:49'!
testRunLightsAndSetGoLightToGreen

	self createPassingTestInDummyTestClass.
	self assertAllBulbsOfGolightAreOff.
	golightTester run.
	self assert: golight greenBulb isOn.
	self deny: golight yellowBulb isOn.
	self deny: golight redBulb isOn! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/18/2008 00:49'!
testRunLightsAndSetGoLightToRed

	self
		createDefectiveTestInDummyTestClass;
		createFailingTestInDummyTestClass.
	self assertAllBulbsOfGolightAreOff.
	golightTester run.
	self deny: golight greenBulb isOn.
	self deny: golight yellowBulb isOn.
	self assert: golight redBulb isOn! !

!GoLightAcceptanceTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 21:20'!
testRunLightsAndSetGoLightToYellow

	self createFailingTestInDummyTestClass.
	self assertAllBulbsOfGolightAreOff.
	golightTester run.
	self deny: golight greenBulb isOn.
	self assert: golight yellowBulb isOn.
	self deny: golight redBulb isOn.! !

TestCase subclass: #GoLightBulbTest
	instanceVariableNames: 'powerManager sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightBulbTest methodsFor: 'running' stamp: 'rkrk 2/17/2008 17:24'!
setUp

	super setUp.
	powerManager := GoLightPowerManagerMock new.
	sut := GoLightBulb new.! !

!GoLightBulbTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 22:21'!
testSwitchOff

	powerManager setSocketToStateTestBlock: [:socketNumber :state |
		self assert: state = #off].
	
	sut powerManager: powerManager.

	self deny: sut isOn.
	sut state: #on.
	sut off.! !

!GoLightBulbTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 21:33'!
testSwitchOn

	powerManager setSocketToStateTestBlock: [:socketNumber :state |
		self assert: state = #on].
	
	sut powerManager: powerManager.

	self deny: sut isOn.
	sut on.
	self assert: sut isOn.! !

TestCase subclass: #GoLightTestTimeTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightTestTimeTest methodsFor: 'running' stamp: 'rkrk 2/17/2008 22:58'!
setUp

	| startTime stopTime |
	super setUp.

	startTime := Time hour: 12 minute: 20 second: 0.
	stopTime := Time hour: 15 minute: 22 second: 0.
	sut := GoLightTestTime
				delay: (Delay forSeconds: 1)
				start: startTime
				end: stopTime
				testingDays: {}.! !

!GoLightTestTimeTest methodsFor: 'tests' stamp: 'test 2/17/2008 23:04'!
testShouldIncludeDateAndTime

	| aDateAndTime |
	sut testingDays: {Date today dayOfWeekName}.
	aDateAndTime := DateAndTime date: Date current time: (sut start addSeconds: 60).
	self assert: (sut activeAtDateAndTime: aDateAndTime)! !

!GoLightTestTimeTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 17:20'!
testShouldNotIncludeBecauseOfDay
			
	| aDateAndTime |
	sut testingDays: {}.
	aDateAndTime := DateAndTime date: Date current time: (sut start addSeconds: 60).
	self deny: (sut activeAtDateAndTime: aDateAndTime)! !

!GoLightTestTimeTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 17:21'!
testShouldNotIncludeBecauseOfTime
			
	| aDateAndTime |
	sut testingDays: {Date today dayOfWeek}.
	aDateAndTime := DateAndTime date: Date current time: (sut start addSeconds: -60).
	self deny: (sut activeAtDateAndTime: aDateAndTime)! !

TestCase subclass: #GoLightTesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightTesterTest methodsFor: 'helper' stamp: 'rkrk 2/17/2008 19:44'!
mcPackageForThisCategory
	
	| categoryName |
	categoryName := (self class category subStrings: '-') first.
	^ MCPackage allInstances
		detect: [:each | each name = categoryName]
		ifNone: [self assert: false description: 'There should be a MCPackage of GoLight...'].
! !

!GoLightTesterTest methodsFor: 'tests' stamp: 'rkrk 2/17/2008 21:34'!
testFindTestCasesInMCPackage

	| mcPackage expected sut |
	mcPackage := self mcPackageForThisCategory.
	sut := GoLightTester forMCPackage: mcPackage.
	
	expected := (SystemOrganization listAtCategoryNamed: self class category)
			collect: [:className | Smalltalk at: className]
			thenSelect: [:class | class inheritsFrom: TestCase].
	
	self assert: sut testClasses asSet = expected asSet.! !

TestCase subclass: #GoLightVersionUpdaterTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GoLight-Tests'!

!GoLightVersionUpdaterTest methodsFor: 'as yet unclassified' stamp: 'rkrk 2/18/2008 01:26'!
setUp

	super setUp.
	
	sut := GoLightVersionUpdater new.! !

!GoLightVersionUpdaterTest methodsFor: 'as yet unclassified' stamp: 'rkrk 2/18/2008 01:26'!
testFindNewestVersionName

	| versionNames versionNameFound |
	versionNames := #('SqueakSVN-rkrk.18' 'SqueakSVN-rkrk.19' 'SqueakSVN-rkrk.17' ).
	versionNameFound := sut findNameOfNewestVersionOf: versionNames.
	self assert: versionNameFound = 'SqueakSVN-rkrk.19'.! !
